/*
 *  ***** BEGIN LICENSE BLOCK *****
 *
 *  Version: MPL 1.1
 *
 *  The contents of this file are subject to the Mozilla Public License Version
 *  1.1 (the "License"); you may not use this file except in compliance with
 *  the License. You may obtain a copy of the License at
 *  http://www.mozilla.org/MPL/
 *
 *  Software distributed under the License is distributed on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 *  for the specific language governing rights and limitations under the
 *  License.
 *
 *  The Original Code is "Zemberek Dogal Dil Isleme Kutuphanesi"
 *
 *  The Initial Developer of the Original Code is
 *  Ahmet A. Akin, Mehmet D. Akin.
 *  Portions created by the Initial Developer are Copyright (C) 2006
 *  the Initial Developer. All Rights Reserved.
 *
 *  Contributor(s):
 *
 *  ***** END LICENSE BLOCK *****
 */

package net.zemberek.kullanim;

import net.zemberek.erisim.Zemberek;
import net.zemberek.islemler.TurkceYaziTesti;
import net.zemberek.tr.yapi.TurkiyeTurkcesi;

public class TestTurkceMi {

    private static Zemberek zemberek;

    public static void turkceMi(String str) {
        System.out.print("Trke testi yaplan metin: " + str + " Sonu : ");
        int sonuc = zemberek.dilTesti(str);
        switch (sonuc) {
            case TurkceYaziTesti.KESIN:
                System.out.println("Trke");
                break;
            case TurkceYaziTesti.YUKSEK:
                System.out.println("Yksek oranda Trke");
                break;
            case TurkceYaziTesti.ORTA:
                System.out.println("Ksmen Trke");
                break;
            case TurkceYaziTesti.AZ:
                System.out.println("ok az Trke kelime ieriyor");
                break;
            case TurkceYaziTesti.HIC:
                System.out.println("Trke deil");
                break;
        }
    }

    public static void main(String[] args) {
        zemberek = new Zemberek(new TurkiyeTurkcesi());
        turkceMi("Bugn ok neeliyim, hayat ok gzel");
        turkceMi("Abi yaptmz son commitler nasty regresyonlara yol am. we are doomed yani.");
        turkceMi("Bugun cok neseliyim, hayat cok guzel");
        turkceMi("Obviously Java kicks some serious butts nowadays.");
    }
}
